Compare commits

..

10 Commits

Author SHA1 Message Date
Ettore Di Giacinto 66284024a2 Use new eit options 2018-06-02 13:38:31 +02:00
Ettore Di Giacinto 64f8ee54a3 functions: make /opt/sabayon-build/ configurable 2018-02-15 00:07:41 +01:00
Ettore Di Giacinto 6cc8d3d7ae switch default profile 2018-02-03 22:56:16 +01:00
Ettore Di Giacinto 7512a7f184 push experimental sabayon-commit 2018-01-23 21:51:28 +01:00
Ettore Di Giacinto bdd6ffac8c Merge pull request #17 from geaaru/fix_builder_debug
[builder] Fix print of $remove_layman_overlay
2018-01-17 17:52:22 +01:00
Geaaru b42ef2feb7 [builder] Fix print of $remove_layman_overlay 2018-01-17 09:31:13 +01:00
Ettore Di Giacinto cf77609a7b Merge pull request #16 from geaaru/documentation
Add documentation
2018-01-15 18:42:33 +01:00
Geaaru dc05aace0b Add documentation 2018-01-15 15:45:13 +01:00
Ettore Di Giacinto 928d6da693 Refactorize and quote package when getting deps of package 2017-07-30 01:43:17 +02:00
Ettore Di Giacinto 5c927a25c6 Refactorizations 2017-07-30 01:26:11 +02:00
5 changed files with 271 additions and 17 deletions
+178
View File
@@ -0,0 +1,178 @@
# Scripts
Devkit contains a list of scripts used by Sabayon for building process and
for manage package injection to repositories.
## List of files
* `depcheck`: a tool to report both undeclared and potentially-unused
runtime dependencies.
* `dynlink-scanner`: a tool for retrieve list of linked libraries used
by a package. Use try_dlopen execute binary.
* `sabayon-brokenlibs`: a tool for retrieve list of all dependencies
of a binary through equo and equery tools. Print list of dependencies.
This script depends on:
- equo
- equery
- sabayondevkit-functions.sh
* `sabayon-buildpackages`: Script for Spawning the package builder container.
This script depends on:
- sabayondevkit-functions.sh
* `sabayon-bz2brokenlibs`: Unpack bz2 tarball and execute sabayon-brokenlibs
to every files unpacked.
This script depends on:
- sabayondevkit-functions.sh
* `sabayon-createrepo`: Script for spawning container for commit packages to
a repository and create it if doesn't exists.
This script depends on:
- sabayondevkit-functions.sh
* `sabayon-createrepo-cleanup`: Script for spawning container for cleanup
expired packages from a repository.
This script depends on:
- sabayondevkit-functions.sh
* `sabayon-createrepo-remove`: Script for spawning container for remove a list
of packages from a repository.
This script depends on:
- sabayondevkit-functions.sh
* `sabayon-detectobsolete`: Perl script for found obsolete packages in an
overlay. Possible options are: --arch, --overlay and --verbose.
This script depends on:
- querypkg
* `sabayon-entropypreservedlibs`: Perl script for retrieve list of packages that has
dependencies to old libraries.
See also [here](https://wiki.sabayon.org/index.php?title=En:Sabayon_Devkit#sabayon-entropypreservedlibs)
* `sabayon-help-info`: Bash script for grabbing system information and post to
sabayon pastebin.
This script depends on:
- pastebunz
* `sabayon-maint-helper`: Script for builder boxes maintenance.
Possible options are:
- `--installed`: For upgrades all the packages installed in the box.
- `--obsolete`: Upgrade ONLY the packages that are listed obsolete
- `--all`: Tries to upgrade all packages
- `--category`: Tries to upgrade/install all packages present in a specified category.
This script depends on:
- sabayondevkit-functions.sh
* `sabayon-tbz2extract`: Python script for extract tbz2 package.
* `sabayon-tbz2truncate`: Python script for truncate tbz2 package
* `sabayon-xpakextract`: Python script for convert tbz2 in .xpak file
* `builder`: Perl script for build packages.
## Scripts Variables
### sabayon-createrepo
| Env Variable | Default | Description |
|--------------|---------|-------------|
| SAB_WORKSPACE | $PWD | Workspace directory |
| REPOSITORY_NAME | default | Name of the repository to create. |
| REPOSITORY_DESCRIPTION | My Sabayon repository | Description of the repository to create. |
| DOCKER_IMAGE | sabayon/eit-amd64 | Docker image to use on create repository |
| PORTAGE_ARTIFACTS | $SAB_WORKSPACE/portage_artifacts | Directory of the artifacts to insert on repository |
| OUTPUT_DIR | $SAB_WORKSPACE/entropy_artifacts | Output directory of the repository |
| DOCKER_OPTS | --ti --rm | Docker options to pass on run container. |
| PUBKEY | - | Define file to mount as volume to /etc/entropy/mykeys/key.pub |
| PRIVATEKEY | - | Define file to mount as volume to /etc/entropy/mykeys/private.key |
### sabayon-createrepo-cleanup
| Env Variable | Default | Description |
|--------------|---------|-------------|
| SAB_WORKSPACE | $PWD | Workspace directory |
| REPOSITORY_NAME | default | Name of the repository to clean. |
| REPOSITORY_DESCRIPTION | My Sabayon repository | Description of the repository to clean. |
| DOCKER_IMAGE | sabayon/eit-amd64 | Docker image to use on clean repository |
| OUTPUT_DIR | $SAB_WORKSPACE/entropy_artifacts | Directory of the repository |
| DOCKER_OPTS | --ti --rm | Docker options to pass on run container. |
| PUBKEY | - | Define file to mount as volume to /etc/entropy/mykeys/key.pub |
| PRIVATEKEY | - | Define file to mount as volume to /etc/entropy/mykeys/private.key |
### sabayon-createrepo-remove
| Env Variable | Default | Description |
|--------------|---------|-------------|
| SAB_WORKSPACE | $PWD | Workspace directory |
| REPOSITORY_NAME | default | Name of the repository where remove packages. |
| REPOSITORY_DESCRIPTION | My Sabayon repository | Description of the repository. |
| DOCKER_IMAGE | sabayon/eit-amd64 | Docker image to use on clean repository |
| OUTPUT_DIR | $SAB_WORKSPACE/entropy_artifacts | Directory of the repository |
| DOCKER_OPTS | --ti --rm | Docker options to pass on run container. |
| PUBKEY | - | Define file to mount as volume to /etc/entropy/mykeys/key.pub |
| PRIVATEKEY | - | Define file to mount as volume to /etc/entropy/mykeys/private.key |
### sabayon-buildpackages
| Env Variable | Default | Description |
|--------------|---------|-------------|
| SAB_WORKSPACE | $PWD | Workspace directory |
| DOCKER_IMAGE | sabayon/builder-amd64 | Docker image to use for compilation |
| SAB_ARCH | intel | Name of arch to use defined on build Sabayon project |
| DOCKER_PULL_IMAGE | 0 | If try to pull last image (1) or use local version |
| MAKE_CONF | $SAB_WORKSPACE/specs/make.conf | Path of make.conf custom to supply on compilation |
| OUTPUT_DIR | $SAB_WORKSPACE/portage_artifacts/ | Where are written portage artifacts compiled |
| LOCAL_OVERLAY | $SAB_WORKSPACE/local_overlay/ | Directory to use for supply local overlay as volume of the image on compilation |
| ENTROPY_REPOSITORY | main | Sabayon repository to use: weekly, main or testing |
| DOCKER_OPTS | --ti --rm --cap-add=SYS_PTRACE | Options to use on running Docker image |
| PORTAGE_CACHE | - | If present permit to supply host portage directory to container |
| BUILDER_PROFILE | - | Permit to choice Gentoo Profile to use |
| EMERGE_SPLIT_INSTALL | - | Possible values are 0/1. |
| BUILDER_JOBS | 1 | Define number of jobs for emerge phase. |
| USE_EQUO | 1 | Use equo for install and align compilation environment. |
| PRESERVED_REBUILD | 0 | Execute (emerge @preserve-rebuild) |
| EQUO_INSTALL_ATOMS | 1 | Try to install existing dependencies from equo repositories |
| DEPENDENCY_SCAN_DEPTH | 2 | Define depth level for dependencies calculation |
| FEATURES | "parallel-fetch protect-owned compressdebug splitdebug -userpriv" | Override Gentoo FEATURES variable |
| EMERGE_DEFAULTS_ARGS | "--accept-properties=-interactive --verbose --oneshot --complete-graph --buildpkg" | Override default emerge options |
| EQUO_INSTALL_VERSION | 0 | |
| EQUO_SPLIT_INSTALL | 0 | |
| ARTIFACTS_DIR | - | Additional directory where copy artifacts |
| ENTROPY_REPOSITORY | main | Choice repository to use. Values: main, weekly, testing |
| SKIP_PORTAGE_SYNC | 0 | Skip portage sync before compilation |
| EQUO_MIRRORSORT | 1 | Execute equo mirrorsort before compilation |
| WEBRSYNC | 0 | Use webrsync instead of defult rsync |
| ENMAN_REPOSITORIES | - | Define list of enman repositories to add |
| REMOVE_ENMAN_REPOSITORIES | - | Define list of enman repositories to remove |
| DISTFILES | - | Permit to mount volume to /usr/portage/distfiles directory and speedup download phase if packages are already available |
| INTERNAL_BUILDER | - | Define a host builder to use instead of docker builder binary |
| ENTROPY_DOWNLOADED_PACKAGES | - | Mount volume to /var/lib/entropy/client/packages to use caching on download equo packages |
| DISTCC_HOSTS | - | Override Gentoo DISTCC_HOSTS variable to use DISTCC |
| PRUNE_VIRTUALS | 0 | Prune virtuals packages to avoid conflicts. |
| REPOSITORY_NAME | - | Add single enman repository (for compilation of scr repository itself) |
| ENMAN_ADD_SELF | 0 | If add with enman repository define on REPOSITORY_NAME variable |
| EQUO_MASKS | - | Define a list of packages to mask with equo mask command |
| EQUO_UNMASKS | - | Define a list of packages to unmask with equo unmask command |
| EMERGE_REMOVE | - | Define a list of packages to remove with emerge -C command before compilation |
| REMOTE_OVERLAY | - | Define a list of overlay to add before compilation |
| REMOVE_LAYMAN_OVERLAY | - | Define a list of overlays to remove before compilation |
| REMOTE_REMOTE_OVERLAY | - | Define a list of files under /etc/portage to remove |
| QA_CHECKS | - | Execute quality check on packages. repoman, dynlink-scanner and depcheck |
| REMOTE_CONF_PORTDIR | - | If defined permit to define a git repository to clone under /etc/portage directory. |
| REMOTE_PORTDIR | - | If defined permit to define a git repository to clone under /usr/portage directory. |
| ETP_NOCACHE | - | Define ETP_NOCACHE variable on environment |
| PRETEND | 0 | If set to 1 append -p option to emerge commands. |
| BUILDER_VERBOSE | 0 | If set to 1 add verbose to builder program. |
| DETECT_OBSOLETE | 0 | Execute script sabayon-detectobsolete to target overlay to found obsolete ebuilds. |
| TARGET_OVERLAY | - | Define overlay where execute sabayon-detectobsolete script. Require DETECT_OBSOLETE variable set to 1. |
| LOCAL_OVERLAY | - | Define a directory to mount as volume to /usr/local/local_portage |
| SHARE_WORKSPACE | - | If defined mount volume defined on SAB_WORKSPACE variable to /devkit-workspace |
| PRE_SCRIPT | - | Mount a custom script to /pre-script execute before compilation |
| POST_SCRIPT | - | Mount a custom script to /post-script execute after packages compilation |
| MAKE_CONF | - | If defined mount defined file to /etc/portage/make.conf.custom and define variable MAKE_CONF to bet to mounted path. |
+8 -14
View File
@@ -5,7 +5,7 @@ use v5.10;
no feature "say";
use Storable 'dclone';
my $profile = $ENV{BUILDER_PROFILE} // 3;
my $profile = $ENV{BUILDER_PROFILE} // 16;
my $jobs = $ENV{BUILDER_JOBS} // 1;
my $use_equo = $ENV{USE_EQUO} // 1;
my $preserved_rebuild = $ENV{PRESERVED_REBUILD} // 0;
@@ -148,9 +148,8 @@ sub package_deps {
$cache_key = "${package}:${depth}:${atom}";
if ( !exists $package_dep_cache{$cache_key} ) {
my $local_p = to_abs_atom($package);
my @dependencies =
qx/equery -C -q g --depth=$depth $local_p/; #depth=0 it's all
qx/equery -C -q g --depth=$depth '$package'/; #depth=0 it's all
chomp @dependencies;
# If an unversioned atom is given, equery returns results for all versions in the portage tree
@@ -244,14 +243,9 @@ sub atom { s/-[0-9]{1,}.*$//; }
sub abs_atom { atom; s/^(\<|\>|=)+// }
# Same again as a function
sub to_atom { my $p = shift; $p =~ s/-[0-9]{1,}.*$//; return $p; }
sub to_atom { my $p = shift; local $_ = $p; atom; return $_; }
sub to_abs_atom {
my $p = shift;
$p = to_atom($p);
$p =~ s/^(\<|\>|=)+//;
return $p;
}
sub to_abs_atom { my $p = shift; local $_ = $p; abs_atom; return $_; }
# Input: Array
# Output: array with unique elements
@@ -422,7 +416,7 @@ if ( $remote_overlay and $remote_overlay ne "" ) {
}
if ( $remove_layman_overlay and $remove_layman_overlay ne "" ) {
say "===== Removing overlays: $remove_remote_overlay =====";
say "===== Removing overlays: $remove_layman_overlay =====";
_system("layman -d $_") for ( split( / /, $remove_layman_overlay ) );
}
@@ -619,12 +613,12 @@ if ( $qualityassurance_checks == 1 ) {
{
say ">> Running repoman on $pn";
_system(
"pushd \$(dirname \$(equery which $pn 2>/dev/null)); repoman; popd"
"pushd \$(dirname \$(equery which '$pn' 2>/dev/null)); repoman; popd"
);
$pn =~ s/\:\:.*//g;
say ">> Detecting missing dependencies for $pn";
_system("dynlink-scanner $pn");
_system("depcheck $pn");
_system("dynlink-scanner '$pn'");
_system("depcheck '$pn'");
}
}
+80
View File
@@ -0,0 +1,80 @@
#!/usr/bin/perl
use feature 'say';
use Cwd;
use File::Temp;
my $current_git_directory = qx|git rev-parse --show-toplevel 2>/dev/null|;
chomp $current_git_directory;
my $cwd = getcwd;
chdir($current_git_directory);
my $commit_message_tmpfile = File::Temp->new();
my @changed_files = qx|git status -s|;
my $n_changed_files = scalar @changed_files;
die "No files changed. Exiting." if $n_changed_files <= 0;
my %atoms = ();
sub _build_git_repo {
my ($file_name) = @_;
my $commit_message;
if ( $file_name
=~ /conf\/(home|intel|arm(arch|hfp|v6l|vtl))\/(entropy|portage|repo)\/(.*)/
)
{
$commit_message = "$1/$4: ";
}
elsif ( $filename eq
"conf/noarch/entropy/packages/packages.server.dep_blacklist" )
{
$commit_message = "dep_blacklist: ";
}
elsif ( $filename eq
"conf/noarch/entropy/packages/packages.server.dep_rewrite" )
{
$commit_message = "dep_rewrite: ";
}
if ($commit_message) {
print $commit_message_tmpfile $commit_message;
system( "git commit -eF " . $commit_message_tmpfile->filename );
unlink($commit_message_tmpfile) if -e $commit_message_tmpfile;
}
}
sub _overlay_git_repo {
die "If you are in the overlay, call me in the ebuild dir"
if $current_git_directory eq getcwd;
chdir($cwd);
die "I'm not pleased.. but you could force with --force"
if ( _system("repoman") && $ARGV[0] ne "--force" );
_system("repoman commit $ARGV[0]");
}
sub _system {
my $prog = shift;
my $rv = system( {$prog} $prog => @_ );
if ( $rv == -1 ) { say("Can't launch $prog: $!"); return 1; }
elsif ( my $s = $rv & 127 ) {
say("$prog died from signal $s");
return 1;
}
elsif ( my $e = $rv >> 8 ) { say("$prog exited with code $e"); return 1; }
return 0;
}
foreach my $file (@changed_files) {
chomp $file;
my @words = split( ' ', $file, 2 );
next if $words[0] eq "??"; # allow "dangling" files
my $file_name = $words[1];
if ( $file_name =~ /conf\/(intel|arm|noarch)/ ) {
_build_git_repo($file_name);
}
elsif ( $file_name =~ /\.ebuild/ ) {
_overlay_git_repo($file_name);
}
}
+2 -2
View File
@@ -68,8 +68,8 @@ fi
eit key import \$repo /etc/entropy/mykeys/private.key /etc/entropy/mykeys/key.pub && { eit key sign \$repo || true; } && { echo "=== Repository key imported successfully ==="; }
echo "=== Injecting packages ==="
echo "Yes" | eit inject \${built_pkgs} || { echo "ouch unable to inject" && exit 3; }
echo "Yes Yes Yes" | eit commit --quick
eit inject --quick \${built_pkgs} || { echo "ouch unable to inject" && exit 3; }
eit commit --quick
echo "=== Pushing built packages locally ==="
eit push --quick --force
+3 -1
View File
@@ -2,6 +2,8 @@
set -e
export BUILD_DIR="${BUILD_DIR:-/opt/sabayon-build/}"
check_docker_requirements(){
if [ "$(id -u)" != "0" ]; then
groups | grep -q docker || echo "--> If you are not running the script as root, your user should be in the docker group to use it. (sudo gpasswd -a $USER docker)"
@@ -15,7 +17,7 @@ build_sync() {
layman -S
emerge --sync
eix-update
pushd /opt/sabayon-build/
pushd "${BUILD_DIR}"
git stash
git fetch --all || true
git checkout master || true